//-------------------------------------------------------------------------------------------------------
// Copyright (C) Microsoft. All rights reserved.
// Licensed under the MIT license. See LICENSE.txt file in the project root for full license information.
//-------------------------------------------------------------------------------------------------------
package Windows.UI.Xaml.Controls;

class NamedColor {
    static final String AliceBlue = "#FFF0F8FF";
    static final String AntiqueWhite = "#FFFAEBD7";
    static final String Aqua = "#FF00FFFF";
    static final String Aquamarine = "#FF7FFFD4";
    static final String Azure = "#FFF0FFFF";
    static final String Beige = "#FFF5F5DC";
    static final String Bisque = "#FFFFE4C4";
    static final String Black = "#FF000000";
    static final String BlanchedAlmond = "#FFFFEBCD";
    static final String Blue = "#FF0000FF";
    static final String BlueViolet = "#FF8A2BE2";
    static final String Brown = "#FFA52A2A";
    static final String BurlyWood = "#FFDEB887";
    static final String CadetBlue = "#FF5F9EA0";
    static final String Chartreuse = "#FF7FFF00";
    static final String Chocolate = "#FFD2691E";
    static final String Coral = "#FFFF7F50";
    static final String CornflowerBlue = "#FF6495ED";
    static final String Cornsilk = "#FFFFF8DC";
    static final String Crimson = "#FFDC143C";
    static final String Cyan = "#FF00FFFF";
    static final String DarkBlue = "#FF00008B";
    static final String DarkCyan = "#FF008B8B";
    static final String DarkGoldenrod = "#FFB8860B";
    static final String DarkGray = "#FFA9A9A9";
    static final String DarkGreen = "#FF006400";
    static final String DarkKhaki = "#FFBDB76B";
    static final String DarkMagenta = "#FF8B008B";
    static final String DarkOliveGreen = "#FF556B2F";
    static final String DarkOrange = "#FFFF8C00";
    static final String DarkOrchid = "#FF9932CC";
    static final String DarkRed = "#FF8B0000";
    static final String DarkSalmon = "#FFE9967A";
    static final String DarkSeaGreen = "#FF8FBC8F";
    static final String DarkSlateBlue = "#FF483D8B";
    static final String DarkSlateGray = "#FF2F4F4F";
    static final String DarkTurquoise = "#FF00CED1";
    static final String DarkViolet = "#FF9400D3";
    static final String DeepPink = "#FFFF1493";
    static final String DeepSkyBlue = "#FF00BFFF";
    static final String DimGray = "#FF696969";
    static final String DodgerBlue = "#FF1E90FF";
    static final String Firebrick = "#FFB22222";
    static final String FloralWhite = "#FFFFFAF0";
    static final String ForestGreen = "#FF228B22";
    static final String Fuchsia = "#FFFF00FF";
    static final String Gainsboro = "#FFDCDCDC";
    static final String GhostWhite = "#FFF8F8FF";
    static final String Gold = "#FFFFD700";
    static final String Goldenrod = "#FFDAA520";
    static final String Gray = "#FF808080";
    static final String Green = "#FF008000";
    static final String GreenYellow = "#FFADFF2F";
    static final String Honeydew = "#FFF0FFF0";
    static final String HotPink = "#FFFF69B4";
    static final String IndianRed = "#FFCD5C5C";
    static final String Indigo = "#FF4B0082";
    static final String Ivory = "#FFFFFFF0";
    static final String Khaki = "#FFF0E68C";
    static final String Lavender = "#FFE6E6FA";
    static final String LavenderBlush = "#FFFFF0F5";
    static final String LawnGreen = "#FF7CFC00";
    static final String LemonChiffon = "#FFFFFACD";
    static final String LightBlue = "#FFADD8E6";
    static final String LightCoral = "#FFF08080";
    static final String LightCyan = "#FFE0FFFF";
    static final String LightGoldenrodYellow = "#FFFAFAD2";
    static final String LightGreen = "#FF90EE90";
    static final String LightGray = "#FFD3D3D3";
    static final String LightPink = "#FFFFB6C1";
    static final String LightSalmon = "#FFFFA07A";
    static final String LightSeaGreen = "#FF20B2AA";
    static final String LightSkyBlue = "#FF87CEFA";
    static final String LightSlateGray = "#FF778899";
    static final String LightSteelBlue = "#FFB0C4DE";
    static final String LightYellow = "#FFFFFFE0";
    static final String Lime = "#FF00FF00";
    static final String LimeGreen = "#FF32CD32";
    static final String Linen = "#FFFAF0E6";
    static final String Magenta = "#FFFF00FF";
    static final String Maroon = "#FF800000";
    static final String MediumAquamarine = "#FF66CDAA";
    static final String MediumBlue = "#FF0000CD";
    static final String MediumOrchid = "#FFBA55D3";
    static final String MediumPurple = "#FF9370DB";
    static final String MediumSeaGreen = "#FF3CB371";
    static final String MediumSlateBlue = "#FF7B68EE";
    static final String MediumSpringGreen = "#FF00FA9A";
    static final String MediumTurquoise = "#FF48D1CC";
    static final String MediumVioletRed = "#FFC71585";
    static final String MidnightBlue = "#FF191970";
    static final String MintCream = "#FFF5FFFA";
    static final String MistyRose = "#FFFFE4E1";
    static final String Moccasin = "#FFFFE4B5";
    static final String NavajoWhite = "#FFFFDEAD";
    static final String Navy = "#FF000080";
    static final String OldLace = "#FFFDF5E6";
    static final String Olive = "#FF808000";
    static final String OliveDrab = "#FF6B8E23";
    static final String Orange = "#FFFFA500";
    static final String OrangeRed = "#FFFF4500";
    static final String Orchid = "#FFDA70D6";
    static final String PaleGoldenrod = "#FFEEE8AA";
    static final String PaleGreen = "#FF98FB98";
    static final String PaleTurquoise = "#FFAFEEEE";
    static final String PaleVioletRed = "#FFDB7093";
    static final String PapayaWhip = "#FFFFEFD5";
    static final String PeachPuff = "#FFFFDAB9";
    static final String Peru = "#FFCD853F";
    static final String Pink = "#FFFFC0CB";
    static final String Plum = "#FFDDA0DD";
    static final String PowderBlue = "#FFB0E0E6";
    static final String Purple = "#FF800080";
    static final String Red = "#FFFF0000";
    static final String RosyBrown = "#FFBC8F8F";
    static final String RoyalBlue = "#FF4169E1";
    static final String SaddleBrown = "#FF8B4513";
    static final String Salmon = "#FFFA8072";
    static final String SandyBrown = "#FFF4A460";
    static final String SeaGreen = "#FF2E8B57";
    static final String SeaShell = "#FFFFF5EE";
    static final String Sienna = "#FFA0522D";
    static final String Silver = "#FFC0C0C0";
    static final String SkyBlue = "#FF87CEEB";
    static final String SlateBlue = "#FF6A5ACD";
    static final String SlateGray = "#FF708090";
    static final String Snow = "#FFFFFAFA";
    static final String SpringGreen = "#FF00FF7F";
    static final String SteelBlue = "#FF4682B4";
    static final String Tan = "#FFD2B48C";
    static final String Teal = "#FF008080";
    static final String Thistle = "#FFD8BFD8";
    static final String Tomato = "#FFFF6347";
    static final String Transparent = "#00FFFFFF";
    static final String Turquoise = "#FF40E0D0";
    static final String Violet = "#FFEE82EE";
    static final String Wheat = "#FFF5DEB3";
    static final String White = "#FFFFFFFF";
    static final String WhiteSmoke = "#FFF5F5F5";
    static final String Yellow = "#FFFFFF00";
    static final String YellowGreen = "#FF9ACD32";
    static final String UnknownColor = "#00000001";

    static String toNumericColorString(String namedColor) {
        if (namedColor == null)
            throw new RuntimeException("Null color string");

        String colorUpper = namedColor.toUpperCase();

        // Check names based on the name length
        switch (colorUpper.length()) {
            case 3:
                if (colorUpper.compareTo("RED") == 0) return Red;
                if (colorUpper.compareTo("TAN") == 0) return Tan;
                break;
            case 4:
                switch (colorUpper.charAt(0)) {
                    case 'A':
                        if (colorUpper.compareTo("AQUA") == 0) return Aqua;
                        break;
                    case 'B':
                        if (colorUpper.compareTo("BLUE") == 0) return Blue;
                        break;
                    case 'C':
                        if (colorUpper.compareTo("CYAN") == 0) return Cyan;
                        break;
                    case 'G':
                        if (colorUpper.compareTo("GOLD") == 0) return Gold;
                        if (colorUpper.compareTo("GRAY") == 0) return Gray;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIME") == 0) return Lime;
                        break;
                    case 'N':
                        if (colorUpper.compareTo("NAVY") == 0) return Navy;
                        break;
                    case 'P':
                        if (colorUpper.compareTo("PERU") == 0) return Peru;
                        if (colorUpper.compareTo("PINK") == 0) return Pink;
                        if (colorUpper.compareTo("PLUM") == 0) return Plum;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SNOW") == 0) return Snow;
                        break;
                    case 'T':
                        if (colorUpper.compareTo("TEAL") == 0) return Teal;
                        break;
                }
                break;
            case 5:
                switch (colorUpper.charAt(0)) {
                    case 'A':
                        if (colorUpper.compareTo("AZURE") == 0) return Azure;
                        break;
                    case 'B':
                        if (colorUpper.compareTo("BEIGE") == 0) return Beige;
                        if (colorUpper.compareTo("BLACK") == 0) return Black;
                        if (colorUpper.compareTo("BROWN") == 0) return Brown;
                        break;
                    case 'C':
                        if (colorUpper.compareTo("CORAL") == 0) return Coral;
                        break;
                    case 'G':
                        if (colorUpper.compareTo("GREEN") == 0) return Green;
                        break;
                    case 'I':
                        if (colorUpper.compareTo("IVORY") == 0) return Ivory;
                        break;
                    case 'K':
                        if (colorUpper.compareTo("KHAKI") == 0) return Khaki;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LINEN") == 0) return Linen;
                        break;
                    case 'O':
                        if (colorUpper.compareTo("OLIVE") == 0) return Olive;
                        break;
                    case 'W':
                        if (colorUpper.compareTo("WHEAT") == 0) return Wheat;
                        if (colorUpper.compareTo("WHITE") == 0) return White;
                        break;
                }
                break;
            case 6:
                switch (colorUpper.charAt(0)) {
                    case 'B':
                        if (colorUpper.compareTo("BISQUE") == 0) return Bisque;
                        break;
                    case 'I':
                        if (colorUpper.compareTo("INDIGO") == 0) return Indigo;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MAROON") == 0) return Maroon;
                        break;
                    case 'O':
                        if (colorUpper.compareTo("ORANGE") == 0) return Orange;
                        if (colorUpper.compareTo("ORCHID") == 0) return Orchid;
                        break;
                    case 'P':
                        if (colorUpper.compareTo("PURPLE") == 0) return Purple;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SALMON") == 0) return Salmon;
                        if (colorUpper.compareTo("SIENNA") == 0) return Sienna;
                        if (colorUpper.compareTo("SILVER") == 0) return Silver;
                        break;
                    case 'T':
                        if (colorUpper.compareTo("TOMATO") == 0) return Tomato;
                        break;
                    case 'V':
                        if (colorUpper.compareTo("VIOLET") == 0) return Violet;
                        break;
                    case 'Y':
                        if (colorUpper.compareTo("YELLOW") == 0) return Yellow;
                        break;
                }
                break;
            case 7:
                switch (colorUpper.charAt(0)) {
                    case 'C':
                        if (colorUpper.compareTo("CRIMSON") == 0) return Crimson;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKRED") == 0) return DarkRed;
                        if (colorUpper.compareTo("DIMGRAY") == 0) return DimGray;
                        break;
                    case 'F':
                        if (colorUpper.compareTo("FUCHSIA") == 0) return Fuchsia;
                        break;
                    case 'H':
                        if (colorUpper.compareTo("HOTPINK") == 0) return HotPink;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MAGENTA") == 0) return Magenta;
                        break;
                    case 'O':
                        if (colorUpper.compareTo("OLDLACE") == 0) return OldLace;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SKYBLUE") == 0) return SkyBlue;
                        break;
                    case 'T':
                        if (colorUpper.compareTo("THISTLE") == 0) return Thistle;
                        break;
                }
                break;
            case 8:
                switch (colorUpper.charAt(0)) {
                    case 'C':
                        if (colorUpper.compareTo("CORNSILK") == 0) return Cornsilk;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKBLUE") == 0) return DarkBlue;
                        if (colorUpper.compareTo("DARKCYAN") == 0) return DarkCyan;
                        if (colorUpper.compareTo("DARKGRAY") == 0) return DarkGray;
                        if (colorUpper.compareTo("DEEPPINK") == 0) return DeepPink;
                        break;
                    case 'H':
                        if (colorUpper.compareTo("HONEYDEW") == 0) return Honeydew;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LAVENDER") == 0) return Lavender;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MOCCASIN") == 0) return Moccasin;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SEAGREEN") == 0) return SeaGreen;
                        if (colorUpper.compareTo("SEASHELL") == 0) return SeaShell;
                        break;
                }
                break;
            case 9:
                switch (colorUpper.charAt(0)) {
                    case 'A':
                        if (colorUpper.compareTo("ALICEBLUE") == 0) return AliceBlue;
                        break;
                    case 'B':
                        if (colorUpper.compareTo("BURLYWOOD") == 0) return BurlyWood;
                        break;
                    case 'C':
                        if (colorUpper.compareTo("CADETBLUE") == 0) return CadetBlue;
                        if (colorUpper.compareTo("CHOCOLATE") == 0) return Chocolate;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKGREEN") == 0) return DarkGreen;
                        if (colorUpper.compareTo("DARKKHAKI") == 0) return DarkKhaki;
                        break;
                    case 'F':
                        if (colorUpper.compareTo("FIREBRICK") == 0) return Firebrick;
                        break;
                    case 'G':
                        if (colorUpper.compareTo("GAINSBORO") == 0) return Gainsboro;
                        if (colorUpper.compareTo("GOLDENROD") == 0) return Goldenrod;
                        break;
                    case 'I':
                        if (colorUpper.compareTo("INDIANRED") == 0) return IndianRed;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LAWNGREEN") == 0) return LawnGreen;
                        if (colorUpper.compareTo("LIGHTBLUE") == 0) return LightBlue;
                        if (colorUpper.compareTo("LIGHTCYAN") == 0) return LightCyan;
                        if (colorUpper.compareTo("LIGHTGRAY") == 0) return LightGray;
                        if (colorUpper.compareTo("LIGHTPINK") == 0) return LightPink;
                        if (colorUpper.compareTo("LIMEGREEN") == 0) return LimeGreen;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MINTCREAM") == 0) return MintCream;
                        if (colorUpper.compareTo("MISTYROSE") == 0) return MistyRose;
                        break;
                    case 'O':
                        if (colorUpper.compareTo("OLIVEDRAB") == 0) return OliveDrab;
                        if (colorUpper.compareTo("ORANGERED") == 0) return OrangeRed;
                        break;
                    case 'P':
                        if (colorUpper.compareTo("PALEGREEN") == 0) return PaleGreen;
                        if (colorUpper.compareTo("PEACHPUFF") == 0) return PeachPuff;
                        break;
                    case 'R':
                        if (colorUpper.compareTo("ROSYBROWN") == 0) return RosyBrown;
                        if (colorUpper.compareTo("ROYALBLUE") == 0) return RoyalBlue;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SLATEBLUE") == 0) return SlateBlue;
                        if (colorUpper.compareTo("SLATEGRAY") == 0) return SlateGray;
                        if (colorUpper.compareTo("STEELBLUE") == 0) return SteelBlue;
                        break;
                    case 'T':
                        if (colorUpper.compareTo("TURQUOISE") == 0) return Turquoise;
                        break;
                }
                break;
            case 10:
                switch (colorUpper.charAt(0)) {
                    case 'A':
                        if (colorUpper.compareTo("AQUAMARINE") == 0) return Aquamarine;
                        break;
                    case 'B':
                        if (colorUpper.compareTo("BLUEVIOLET") == 0) return BlueViolet;
                        break;
                    case 'C':
                        if (colorUpper.compareTo("CHARTREUSE") == 0) return Chartreuse;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKORANGE") == 0) return DarkOrange;
                        if (colorUpper.compareTo("DARKORCHID") == 0) return DarkOrchid;
                        if (colorUpper.compareTo("DARKSALMON") == 0) return DarkSalmon;
                        if (colorUpper.compareTo("DARKVIOLET") == 0) return DarkViolet;
                        if (colorUpper.compareTo("DODGERBLUE") == 0) return DodgerBlue;
                        break;
                    case 'G':
                        if (colorUpper.compareTo("GHOSTWHITE") == 0) return GhostWhite;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIGHTCORAL") == 0) return LightCoral;
                        if (colorUpper.compareTo("LIGHTGREEN") == 0) return LightGreen;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MEDIUMBLUE") == 0) return MediumBlue;
                        break;
                    case 'P':
                        if (colorUpper.compareTo("PAPAYAWHIP") == 0) return PapayaWhip;
                        if (colorUpper.compareTo("POWDERBLUE") == 0) return PowderBlue;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SANDYBROWN") == 0) return SandyBrown;
                        break;
                    case 'W':
                        if (colorUpper.compareTo("WHITESMOKE") == 0) return WhiteSmoke;
                        break;
                }
                break;
            case 11:
                switch (colorUpper.charAt(0)) {
                    case 'D':
                        if (colorUpper.compareTo("DARKMAGENTA") == 0) return DarkMagenta;
                        if (colorUpper.compareTo("DEEPSKYBLUE") == 0) return DeepSkyBlue;
                        break;
                    case 'F':
                        if (colorUpper.compareTo("FLORALWHITE") == 0) return FloralWhite;
                        if (colorUpper.compareTo("FORESTGREEN") == 0) return ForestGreen;
                        break;
                    case 'G':
                        if (colorUpper.compareTo("GREENYELLOW") == 0) return GreenYellow;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIGHTSALMON") == 0) return LightSalmon;
                        if (colorUpper.compareTo("LIGHTYELLOW") == 0) return LightYellow;
                        break;
                    case 'N':
                        if (colorUpper.compareTo("NAVAJOWHITE") == 0) return NavajoWhite;
                        break;
                    case 'S':
                        if (colorUpper.compareTo("SADDLEBROWN") == 0) return SaddleBrown;
                        if (colorUpper.compareTo("SPRINGGREEN") == 0) return SpringGreen;
                        break;
                    case 'T':
                        if (colorUpper.compareTo("TRANSPARENT") == 0) return Transparent;
                        break;
                    case 'Y':
                        if (colorUpper.compareTo("YELLOWGREEN") == 0) return YellowGreen;
                        break;
                }
                break;
            case 12:
                switch (colorUpper.charAt(0)) {
                    case 'A':
                        if (colorUpper.compareTo("ANTIQUEWHITE") == 0) return AntiqueWhite;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKSEAGREEN") == 0) return DarkSeaGreen;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIGHTSKYBLUE") == 0) return LightSkyBlue;
                        if (colorUpper.compareTo("LEMONCHIFFON") == 0) return LemonChiffon;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MEDIUMORCHID") == 0) return MediumOrchid;
                        if (colorUpper.compareTo("MEDIUMPURPLE") == 0) return MediumPurple;
                        if (colorUpper.compareTo("MIDNIGHTBLUE") == 0) return MidnightBlue;
                        break;
                }
                break;
            case 13:
                switch (colorUpper.charAt(0)) {
                    case 'D':
                        if (colorUpper.compareTo("DARKSLATEBLUE") == 0) return DarkSlateBlue;
                        if (colorUpper.compareTo("DARKSLATEGRAY") == 0) return DarkSlateGray;
                        if (colorUpper.compareTo("DARKGOLDENROD") == 0) return DarkGoldenrod;
                        if (colorUpper.compareTo("DARKTURQUOISE") == 0) return DarkTurquoise;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIGHTSEAGREEN") == 0) return LightSeaGreen;
                        if (colorUpper.compareTo("LAVENDERBLUSH") == 0) return LavenderBlush;
                        break;
                    case 'P':
                        if (colorUpper.compareTo("PALEGOLDENROD") == 0) return PaleGoldenrod;
                        if (colorUpper.compareTo("PALETURQUOISE") == 0) return PaleTurquoise;
                        if (colorUpper.compareTo("PALEVIOLETRED") == 0) return PaleVioletRed;
                        break;
                }
                break;
            case 14:
                switch (colorUpper.charAt(0)) {
                    case 'B':
                        if (colorUpper.compareTo("BLANCHEDALMOND") == 0) return BlanchedAlmond;
                        break;
                    case 'C':
                        if (colorUpper.compareTo("CORNFLOWERBLUE") == 0) return CornflowerBlue;
                        break;
                    case 'D':
                        if (colorUpper.compareTo("DARKOLIVEGREEN") == 0) return DarkOliveGreen;
                        break;
                    case 'L':
                        if (colorUpper.compareTo("LIGHTSLATEGRAY") == 0) return LightSlateGray;
                        if (colorUpper.compareTo("LIGHTSTEELBLUE") == 0) return LightSteelBlue;
                        break;
                    case 'M':
                        if (colorUpper.compareTo("MEDIUMSEAGREEN") == 0) return MediumSeaGreen;
                        break;
                }
                break;
            case 15:
                if (colorUpper.compareTo("MEDIUMSLATEBLUE") == 0) return MediumSlateBlue;
                if (colorUpper.compareTo("MEDIUMTURQUOISE") == 0) return MediumTurquoise;
                if (colorUpper.compareTo("MEDIUMVIOLETRED") == 0) return MediumVioletRed;
                break;
            case 16:
                if (colorUpper.compareTo("MEDIUMAQUAMARINE") == 0) return MediumAquamarine;
                break;
            case 17:
                if (colorUpper.compareTo("MEDIUMSPRINGGREEN") == 0) return MediumSpringGreen;
                break;
            case 20:
                if (colorUpper.compareTo("LIGHTGOLDENRODYELLOW") == 0) return LightGoldenrodYellow;
                break;
        }

        throw new RuntimeException("Unknown color " + namedColor);
    }
}
